#include "ast_basic.h"
#include "libsyntax.h"
#include <QDebug>

using namespace ast_basic;
using namespace lib_token;
using namespace lib_syntax;

ExprInstance::ExprInstance(std::shared_ptr<const ExprRule> bind) : _expr_rule(bind) { }

std::shared_ptr<const ExprRule> ExprInstance::definedRule() const {
	return _expr_rule;
}

QString ExprInstance::filePath() const {
	if (!tokens_bind.size())
		throw new SyntaxException(u8"InternalError[0x0002]һյķǷЧڵ");

	return tokens_bind.first()->file();
}

void ExprInstance::addToken(std::shared_ptr<const IToken> token_inst) {
	this->tokens_bind.append(token_inst);
}

QList<std::shared_ptr<const IExprInstance>> ExprInstance::children() const {
	return this->children_store;
}

void ExprInstance::addChild(std::shared_ptr<const IExprInstance> inst) {
	this->children_store.append(inst);
}

QList<std::shared_ptr<const IToken>> ExprInstance::tokens() const {
	return this->tokens_bind;
}

ExprProgram::ExprProgram(const QString& root) : _program_root(root) { }

std::shared_ptr<const ExprRule> ExprProgram::definedRule() const {
	return std::shared_ptr<const ExprRule>();
}

QString ExprProgram::filePath() const {
	return this->_program_root;
}

QList<std::shared_ptr<const IToken>> ExprProgram::tokens() const {
	return QList<std::shared_ptr<const IToken>>();
}

void ExprProgram::addToken(std::shared_ptr<const IToken> token_inst) { }

QList<std::shared_ptr<const IExprInstance>> ExprProgram::children() const {
	return _children_store;
}

void ExprProgram::addChild(std::shared_ptr<const IExprInstance> inst) {
	_children_store.append(inst);
}
