#include "libtokens.h"
#include "tokens_impl.h"

using namespace lib_token;

TokenException::TokenException(const QString& message) : msg_store(message) { }

QString TokenException::message() const {
	return msg_store;
}

TokenContent::TokenContent(int r, int c, uint64_t pos, const QString& t, const QString& p, std::shared_ptr<const ITokenDefine> paramType)
    : row_n(r), col_n(c), doc_offset(pos), text_n(t), path_p(p), type_def(paramType) { }

QString TokenContent::file() const {
    return path_p;
}

uint64_t TokenContent::position() const {
    return doc_offset;
}

QString TokenContent::content() const {
    return text_n;
}

int TokenContent::row() const {
    return row_n;
}

int TokenContent::column() const {
    return col_n;
}

std::shared_ptr<const ITokenDefine> TokenContent::defines() const {
    return this->type_def;
}
